'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactClass = require('react-class');

var _reactClass2 = _interopRequireDefault(_reactClass);

var _reactFlex = require('react-flex');

var _reactInlineBlock = require('react-inline-block');

var _reactInlineBlock2 = _interopRequireDefault(_reactInlineBlock);

var _NavBar = require('./NavBar');

var _NavBar2 = _interopRequireDefault(_NavBar);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _toMoment2 = require('./toMoment');

var _toMoment3 = _interopRequireDefault(_toMoment2);

var _join = require('./join');

var _join2 = _interopRequireDefault(_join);

var _bemFactory = require('./bemFactory');

var _bemFactory2 = _interopRequireDefault(_bemFactory);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ARROWS = _defineProperty({}, -1, _react2.default.createElement(
  'svg',
  { fill: '#000000', height: '24', viewBox: '0 0 24 24', width: '24', xmlns: 'http://www.w3.org/2000/svg' },
  _react2.default.createElement('path', { d: 'M15.41 16.09l-4.58-4.59 4.58-4.59L14 5.5l-6 6 6 6z' }),
  _react2.default.createElement('path', { d: 'M0-.5h24v24H0z', fill: 'none' })
));

var bem = (0, _bemFactory2.default)('react-date-picker__navigation');

var NavigationView = function (_Component) {
  _inherits(NavigationView, _Component);

  function NavigationView(props) {
    _classCallCheck(this, NavigationView);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(NavigationView).call(this, props));

    _this.mounted = false;

    var child = _react2.default.Children.toArray(_this.props.children)[0];

    _this.state = {
      viewDate: child.props.defaultViewDate
    };
    return _this;
  }

  _createClass(NavigationView, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.mounted = true;
    }
  }, {
    key: 'componentWillMount',
    value: function componentWillMount() {
      var child = _react2.default.Children.toArray(this.props.children)[0];

      var prepareProps = child.type && child.type.prototype && child.type.prototype.prepareProps;

      if (prepareProps) {

        var preparedProps = prepareProps.call({
          toMoment: this.toMoment
        }, child.props, this.state);

        this.setState({
          viewMoment: preparedProps.viewMoment
        });
      }
    }
  }, {
    key: 'toMoment',
    value: function toMoment(value, props) {
      props = props || this.props;

      return (0, _toMoment3.default)(value, {
        locale: props.locale,
        dateFormat: props.dateFormat
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var props = this.props;

      var child = this.child = _react2.default.Children.toArray(this.props.children)[0];
      var childProps = child.props || {};

      var config = {
        locale: props.locale || childProps.locale,
        dateFormat: props.dateFormat || childProps.dateFormat
      };
      var theme = props.theme || childProps.theme;

      var viewMoment = childProps.viewDate ? this.toMoment(childProps.viewDate, config) : this.state.viewMoment;

      var view = _react2.default.cloneElement(child, {
        navigation: false,
        viewDate: viewMoment,
        theme: theme,
        locale: config.locale,
        dateFormat: config.dateFormat
      });

      // const prepareProps = child.type && child.type.prototype && child.type.prototype.prepareProps
      // const preparedProps = prepareProps.call({
      //   toMoment: this.toMoment
      // }, view.props, this.state)

      // const prevDisabled = preparedProps.minContrained || (preparedProps.minDateMoment && viewMoment.format('YYYY-MM') == preparedProps.minDateMoment.format('YYYY-MM'))
      // const nextDisabled = preparedProps.maxContrained || (preparedProps.maxDateMoment && viewMoment.format('YYYY-MM') == preparedProps.maxDateMoment.format('YYYY-MM'))

      return _react2.default.createElement(
        _reactFlex.Flex,
        _extends({
          column: true,
          inline: true,
          wrap: false,
          alignItems: 'stretch'
        }, props, {
          className: (0, _join2.default)('react-date-picker__navigation-view', theme && 'react-date-picker__navigation-view--theme-' + theme)
        }),
        _react2.default.createElement(_NavBar2.default, {
          minDate: childProps.minDate,
          maxDate: childProps.maxDate,

          dateFormat: config.dateFormat,
          secondary: props.secondary,
          viewMoment: viewMoment,
          onViewDateChange: this.onViewDateChange
        }),
        view
      );
    }
  }, {
    key: 'onViewDateChange',
    value: function onViewDateChange(dateString, _ref) {
      var dateMoment = _ref.dateMoment;
      var timestamp = _ref.timestamp;

      this.setState({
        viewMoment: dateMoment
      });
    }
  }]);

  return NavigationView;
}(_reactClass2.default);

exports.default = NavigationView;


NavigationView.defaultProps = {
  headerDateFormat: 'MMM YYYY',

  onViewDateChange: function onViewDateChange() {}
};

NavigationView.propTypes = {};